#include "sets2.h"
#include <iostream.h>

unsigned long BinTreeNode::counter = 0;

Set::Set ()
{
  size = 0;
}

Set::~Set()
{
}

Set& Set::add (int)
{
  cerr << "*** can't add to general sets " << endl;
  return *this;
}

bool Set::member (int) const
{
  cerr << "*** can't check membership in general sets " << endl;
  return false;
}

Set& Set::clear()
{
  cerr << "*** can't clear general sets " << endl;
  return *this;
}

void Set::copyMembers (Set& into) const
{
  cerr << "*** can't copy general sets " << endl;
}

/***//**//**//**//**//**//**//**//**/


Set* Set::Generacopia () const                     //funcin que genera copia de set	
{                                                  //como es abstracta no se implementa
  cerr << "*** No puede generar copia " << endl;
  return NULL;
}


/***//**//**//**//**//**//**//**//**/





const Set& Set::operator= (const Set& s)
{
  return *this;
}

/////////////////////////

BinTreeNode::BinTreeNode (int d)
{
  left = right = 0;
  data = d;
  counter++;
}

BinTreeNode::~BinTreeNode ()
{
  --counter;
}

//////////////////////

TreeSet::TreeSet ()
{
  root = 0;
}

bool insert (PBinTreeNode &t, int x)
{
  if (t == 0)
    {
      t = new BinTreeNode(x);
      return true;
    }
  else if (t->data == x)
    {
      return false;
    }
  else if (x < t->data)
    return insert (t->left, x);
  else
    return insert (t->right, x);
}

Set& TreeSet::add (int x)
{
  if (insert (root, x))
     size++;
  return *this;
}

bool TreeSet::member (int x) const
{
  BinTreeNode *t = root;
  while (t != 0)
    {
      if (t->data == x)
	return true;
      else if (x < t->data)
        t = t->left;
      else
	t = t->right;
    }
  return false;
}

void deleteAll (PBinTreeNode& t)
{
  if (t != 0)
    {
      deleteAll(t->left);
      deleteAll(t->right);
      delete t;
      t = 0;
    }
}

Set& TreeSet::clear()
{
  size = 0;
  deleteAll(root);
  return *this;
}


////////////////////////////////////////////////////

/********************* lo mio *********************/

////////////////////////////////////////////////////

//copia en profundidad del rbol binario
//ts puntero raiz rbol destino
//t puntero raiz rbol origen

void TreeSet::copia ( const PBinTreeNode &t,PBinTreeNode &ts)
{
	if (t!=0){                        	 	//pregunta si el rbol origen no est vacio
		ts = new BinTreeNode(t->data);			//agrega un nuevo nodo copiando el dato del rbol origen		
		copia(t->left,ts->left);       	 		//recorre recursivamente hacia la izq.
		copia(t->right,ts->right);     			//recorre recursivamente hacia la der.
 	
	}
}	

/***********************************************/

//se genera el constructor de copia para la estructura TreeSet

TreeSet::TreeSet (const TreeSet& s)
{
	root=0;                               //se inicializa el puntero a la raiz
	clear();                              //elimina recursivamente los nodos del rbol
	copyMembers(s);                       //llama a mtodo que copia los nodos miembros del rbol
	}

/***********************************************/
//copia los nodos miembros del rbol	

void TreeSet::copyMembers(const TreeSet& from)
{

  size=from.size;
	copia(from.root,root);
}
/***********************************************/
//implementacin de la sobrecarga de operador asignacin
	
TreeSet& TreeSet::operator= (const TreeSet &s)
{
	clear();                              //elimina recursivamente los nodos del rbol
	copyMembers(s);                        //llama a mtodo que copia los nodos miembros del rbol
	return *this;                           // se retorna una referencia al objeto
}
/***********************************************/
//funcin que genera copia (duplicado)del rbol	

Set* TreeSet::Generacopia () const
{
	TreeSet *s;
  s= new TreeSet (*this);
	return (s);
}
/***********************************************/
//implementacin del destructor de la clase Treeset

TreeSet::~TreeSet()
{
clear();
}


////////////////////////////////////////////////////

/********************* lo mio *********************/

////////////////////////////////////////////////////



//////////////////////////////////////

ArraySet::ArraySet ()
{
}

Set& ArraySet::add (int x)
{
  if (!member(x))
    {
      members[size] = x;
      size++;
    }
  return *this;
}

bool ArraySet::member (int x) const
{
  for (int i = 0; i < size; i++)
    if (x == members[i])
      return true;
  return false;
}

Set& ArraySet::clear()
{
  size = 0;
  return *this;
}


void ArraySet::copyMembers(ArraySet& into) const
{
  for (int i=0; i<size; i++)
    into.add(members[i]);
}

////////////////////////////////////////////////////

/********************* lo mio *********************/

////////////////////////////////////////////////////

/***********************************************/
//funcin que genera copia (duplicado)del arreglo

Set* ArraySet::Generacopia() const
{
	ArraySet *pa;
	pa= new ArraySet();
	copyMembers(*pa);
	return (pa);
}
/***********************************************/

//implementacin del destructor de la clase Arrayset
ArraySet::~ArraySet()
{
clear();
}
////////////////////////////////////////////////////

/********************* lo mio *********************/

////////////////////////////////////////////////////
//////////////////////////






